Index: trunk/source/Lib/TLibDecoder/TDecCu.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 609)
+++ trunk/source/Lib/TLibDecoder/TDecCu.cpp	(revision 622)
@@ -315,8 +315,23 @@
 #if H_3D_NBDV_REF
       if(pcCU->getSlice()->getVPS()->getDepthRefinementFlag( pcCU->getSlice()->getLayerIdInVps() ))  //Notes from QC: please check the condition for DoNBDV. Remove this comment once it is done.
+      {
         DvInfo.bDV = m_ppcCU[uiDepth]->getDisMvpCandNBDV(&DvInfo, true);
+      }
       else
 #endif
+      {
         DvInfo.bDV = m_ppcCU[uiDepth]->getDisMvpCandNBDV(&DvInfo);
+      }
+
+#if ENC_DEC_TRACE && H_MV_ENC_DEC_TRAC   
+      if ( g_decTraceDispDer )
+      {
+        DTRACE_CU( "RefViewIdx",  DvInfo.m_aVIdxCan );       
+        DTRACE_CU( "MvDisp[x]", DvInfo.m_acNBDV.getHor() );
+        DTRACE_CU( "MvDisp[y]", DvInfo.m_acNBDV.getVer() );
+        DTRACE_CU( "MvRefinedDisp[x]", DvInfo.m_acDoNBDV.getHor() );
+        DTRACE_CU( "MvRefinedDisp[y]", DvInfo.m_acDoNBDV.getVer() );
+      }
+#endif
 
       pcCU->setDvInfoSubParts(DvInfo, uiAbsPartIdx, uiDepth);
@@ -366,22 +381,11 @@
     Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
     memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#if MTK_VSP_FIX_ALIGN_WD_E0172
     InheritedVSPDisInfo inheritedVSPDisInfo[MRG_MAX_NUM_CANDS_MEM];
     m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, numValidMergeCand, uiMergeIndex );
-#else
-#if MTK_VSP_FIX_E0172
-    Int vspDir[MRG_MAX_NUM_CANDS_MEM];
-    memset(vspDir, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-    m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag,vspDir, numValidMergeCand, uiMergeIndex );
-    pcCU->setVSPDirSubParts( vspDir[uiMergeIndex], uiAbsPartIdx, 0, uiDepth );
-#else
-    m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, numValidMergeCand, uiMergeIndex );
-#endif
-#endif// end of MTK_VSP_FIX_ALIGN_WD_E0172
     pcCU->setVSPFlagSubParts( vspFlag[uiMergeIndex], uiAbsPartIdx, 0, uiDepth );
 #else
     m_ppcCU[uiDepth]->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, uiMergeIndex );
 #endif
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
     if(vspFlag[uiMergeIndex])
     {
@@ -400,4 +404,21 @@
         pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMvd( cTmpMv, SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
         pcCU->getCUMvField( RefPicList( uiRefListIdx ) )->setAllMvField( cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ], SIZE_2Nx2N, uiAbsPartIdx, uiDepth );
+#if ENC_DEC_TRACE && H_MV_ENC_DEC_TRAC   
+        if ( g_decTraceMvFromMerge )
+        {        
+          if ( uiRefListIdx == 0 )
+          {
+            DTRACE_PU( "mvL0[0]", cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ].getHor());
+            DTRACE_PU( "mvL0[1]", cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ].getVer());
+            DTRACE_PU( "refIdxL0   ", cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ].getRefIdx());
+          }
+          else
+          {
+            DTRACE_PU( "mvL1[0]", cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ].getHor());
+            DTRACE_PU( "mvL1[1]", cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ].getVer());
+            DTRACE_PU( "refIdxL1", cMvFieldNeighbours[ 2*uiMergeIndex + uiRefListIdx ].getRefIdx());
+          }
+        }
+#endif
       }
     }
Index: trunk/source/Lib/TLibDecoder/TDecEntropy.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 609)
+++ trunk/source/Lib/TLibDecoder/TDecEntropy.cpp	(revision 622)
@@ -243,24 +243,12 @@
           Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
           memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#if MTK_VSP_FIX_ALIGN_WD_E0172
           InheritedVSPDisInfo inheritedVSPDisInfo[MRG_MAX_NUM_CANDS_MEM];
           pcSubCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, inheritedVSPDisInfo, numValidMergeCand );
-#else
-#if MTK_VSP_FIX_E0172
-          Int vspDir[MRG_MAX_NUM_CANDS_MEM];
-          memset(vspDir, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-          pcSubCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, vspDir, numValidMergeCand );
-          pcCU->setVSPDirSubParts( vspDir[uiMergeIndex], uiSubPartIdx, uiPartIdx, uiDepth );
-#else
-          pcSubCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, numValidMergeCand );
-#endif
-#endif//end of MTK_VSP_FIX_ALIGN_WD_E0172
           pcCU->setVSPFlagSubParts( vspFlag[uiMergeIndex], uiSubPartIdx, uiPartIdx, uiDepth );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
+
           if(vspFlag[uiMergeIndex])
           {
             pcCU->setDvInfoSubParts(inheritedVSPDisInfo[uiMergeIndex].m_acDvInfo, uiSubPartIdx, uiPartIdx, uiDepth);
           }
-#endif
 #else
           pcSubCU->getInterMergeCandidates( 0, 0, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand );
@@ -272,28 +260,15 @@
       else
       {
-        uiMergeIndex = pcCU->getMergeIndex(uiSubPartIdx); // Redundant line
+        uiMergeIndex = pcCU->getMergeIndex(uiSubPartIdx);
 #if H_3D_VSP
         Int vspFlag[MRG_MAX_NUM_CANDS_MEM];
         memset(vspFlag, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-#if MTK_VSP_FIX_ALIGN_WD_E0172
         InheritedVSPDisInfo inheritedVSPDisInfo[MRG_MAX_NUM_CANDS_MEM];
         pcSubCU->getInterMergeCandidates( uiSubPartIdx-uiAbsPartIdx, uiPartIdx, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, inheritedVSPDisInfo,numValidMergeCand, uiMergeIndex );
-#else
-#if MTK_VSP_FIX_E0172
-        Int vspDir[MRG_MAX_NUM_CANDS_MEM];
-        memset(vspDir, 0, sizeof(Int)*MRG_MAX_NUM_CANDS_MEM);
-        pcSubCU->getInterMergeCandidates( uiSubPartIdx-uiAbsPartIdx, uiPartIdx, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, vspDir,numValidMergeCand, uiMergeIndex );
-        pcCU->setVSPDirSubParts( vspDir[uiMergeIndex], uiSubPartIdx, uiPartIdx, uiDepth );
-#else
-        pcSubCU->getInterMergeCandidates( uiSubPartIdx-uiAbsPartIdx, uiPartIdx, cMvFieldNeighbours, uhInterDirNeighbours, vspFlag, numValidMergeCand, uiMergeIndex );
-#endif
-#endif//end of MTK_VSP_FIX_ALIGN_WD_E0172
         pcCU->setVSPFlagSubParts( vspFlag[uiMergeIndex], uiSubPartIdx, uiPartIdx, uiDepth );
-#if MTK_VSP_FIX_ALIGN_WD_E0172
         if(vspFlag[uiMergeIndex])
         {
           pcCU->setDvInfoSubParts(inheritedVSPDisInfo[uiMergeIndex].m_acDvInfo, uiSubPartIdx, uiPartIdx, uiDepth);
         }
-#endif
 #else
         pcSubCU->getInterMergeCandidates( uiSubPartIdx-uiAbsPartIdx, uiPartIdx, cMvFieldNeighbours, uhInterDirNeighbours, numValidMergeCand, uiMergeIndex );
@@ -327,5 +302,5 @@
       }
     }
-#if MTK_VSP_FIX_E0172 || MTK_VSP_FIX_ALIGN_WD_E0172
+#if H_3D_VSP
     if ( (pcCU->getInterDir(uiSubPartIdx) == 3) && pcSubCU->isBipredRestriction(uiPartIdx) && (pcCU->getVSPFlag(uiSubPartIdx) == false))
 #else
Index: trunk/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 609)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 622)
@@ -89,5 +89,5 @@
 #if H_3D_DIM_DMM
 , m_cDmm1DataSCModel          ( 1,             1,               NUM_DMM1_DATA_CTX             , m_contextModels + m_numContextModels, m_numContextModels)
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
 , m_cDmm2DataSCModel          ( 1,             1,               NUM_DMM2_DATA_CTX             , m_contextModels + m_numContextModels, m_numContextModels)
 #endif
@@ -179,5 +179,5 @@
 #if H_3D_DIM_DMM
   m_cDmm1DataSCModel.initBuffer          ( sliceType, qp, (UChar*)INIT_DMM1_DATA );
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   m_cDmm2DataSCModel.initBuffer          ( sliceType, qp, (UChar*)INIT_DMM2_DATA );
 #endif
@@ -255,5 +255,5 @@
 #if H_3D_DIM_DMM
   m_cDmm1DataSCModel.initBuffer          ( eSliceType, iQp, (UChar*)INIT_DMM1_DATA );
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   m_cDmm2DataSCModel.initBuffer          ( eSliceType, iQp, (UChar*)INIT_DMM2_DATA );
 #endif
@@ -444,5 +444,5 @@
   ruiTabIdx = uiIdx;
 }
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
 Void TDecSbac::xParseDmm2Offset( Int& riOffset )
 {
@@ -584,8 +584,15 @@
   m_pcTDecBinIf->decodeBin(uiResidual, m_cSDCResidualFlagSCModel.get( 0, 0, 0 ) );
   
+#if H_MV_ENC_DEC_TRAC
+  DTRACE_CU("sdc_residual_flag[i]", uiResidual)
+#endif
+  
   if (uiResidual)
   {
     // decode residual sign bit
     m_pcTDecBinIf->decodeBinEP(uiSign);
+#if H_MV_ENC_DEC_TRAC
+    DTRACE_CU("sdc_residual_sign_flag[i]", uiSign)
+#endif
     
     // decode residual magnitude
@@ -617,5 +624,11 @@
     }
     else
+    {
       uiAbsIdx = uiCount;
+    }
+  
+#if H_MV_ENC_DEC_TRAC
+    DTRACE_CU("sdc_residual_abs_minus1[i]", uiAbsIdx)
+#endif
     
     uiAbsIdx += 1;
@@ -1162,5 +1175,5 @@
       pcCU->setDmmWedgeTabIdxSubParts( uiTabIdx, dimType, absPartIdx, depth );
     } break;
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   case( DMM2_IDX ):
     {
@@ -1333,9 +1346,9 @@
         binNum = 0;
 #if LGE_SDC_REMOVE_DC_E0158
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
         while( symbol && binNum < 2 )
 #endif
 #else
-#if SEC_DMM2_E0146
+#if SEC_DMM2_E0146_HHIFIX
         while( symbol && binNum < 2 )
 #else
@@ -1358,5 +1371,5 @@
     else if( modeCode == 6  ) { dir = (2*DMM3_IDX+DIM_OFFSET); sdcFlag = 0;}
 #if LGE_SDC_REMOVE_DC_E0158
-#if SEC_DMM2_E0146
+#if SEC_DMM2_E0146_HHIFIX
     else if( modeCode == 7 )  { dir = (2* RBC_IDX+DIM_OFFSET); sdcFlag = 0;}
 #else
@@ -1366,5 +1379,5 @@
 #else
     else if( modeCode == 14 ) { dir =      DC_IDX;             sdcFlag = 1;}
-#if SEC_DMM2_E0146
+#if SEC_DMM2_E0146_HHIFIX
     else if( modeCode == 15 ) { dir = (2* RBC_IDX+DIM_OFFSET); sdcFlag = 0;}
 #else
Index: trunk/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 609)
+++ trunk/source/Lib/TLibDecoder/TDecSbac.h	(revision 622)
@@ -102,5 +102,5 @@
 #if H_3D_DIM_DMM
   Void  xParseDmm1WedgeIdx   ( UInt& ruiTabIdx, Int iNumBit );
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   Void  xParseDmm2Offset     ( Int& riOffset );
 #endif
@@ -216,5 +216,5 @@
 #if H_3D_DIM_DMM
   ContextModel3DBuffer m_cDmm1DataSCModel;
-#if !SEC_DMM2_E0146
+#if !SEC_DMM2_E0146_HHIFIX
   ContextModel3DBuffer m_cDmm2DataSCModel;
 #endif
Index: trunk/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 609)
+++ trunk/source/Lib/TLibDecoder/TDecTop.cpp	(revision 622)
@@ -436,4 +436,10 @@
   Window defaultDisplayWindow = pcSlice->getSPS()->getVuiParametersPresentFlag() ? pcSlice->getSPS()->getVuiParameters()->getDefaultDisplayWindow() : Window();
 
+#if H_MV5
+#if H_MV
+    assert( conformanceWindow   .getScaledFlag() ); 
+    assert( defaultDisplayWindow.getScaledFlag() );
+#endif
+#endif
   for( Int temporalLayer=0; temporalLayer < MAX_TLAYER; temporalLayer++) 
   {
@@ -512,5 +518,9 @@
   m_cCuDecoder.destroy();        
 #if H_MV 
+#if H_MV5
+  TComSlice::markIvRefPicsAsShortTerm( m_refPicSetInterLayer0, m_refPicSetInterLayer1 );  
+#else
   TComSlice::markIvRefPicsAsShortTerm( m_refPicSetInterLayer );  
+#endif
   TComSlice::markCurrPic( pcPic ); 
   TComSlice::markIvRefPicsAsUnused   ( m_ivPicLists, targetDecLayerIdSet, m_parameterSetManagerDecoder.getActiveVPS(), m_layerId, poc ); 
@@ -581,5 +591,15 @@
   assert (sps != 0);
 
+#if H_MV5
+#if H_MV
+  TComVPS* vps = m_parameterSetManagerDecoder.getVPS(sps->getVPSId());
+  assert (vps != 0); 
+  if (false == m_parameterSetManagerDecoder.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP(), m_layerId ) )
+#else
   if (false == m_parameterSetManagerDecoder.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP()))
+#endif
+#else
+  if (false == m_parameterSetManagerDecoder.activatePPS(m_apcSlicePilot->getPPSId(),m_apcSlicePilot->isIRAP()))
+#endif
   {
     printf ("Parameter set activation failed!");
@@ -607,5 +627,11 @@
   m_apcSlicePilot->setSPS(sps);
 #if H_MV
+#if H_MV5
+  m_apcSlicePilot->setVPS(vps);  
+  sps->inferRepFormat  ( vps , m_layerId ); 
+  sps->inferScalingList( m_parameterSetManagerDecoder.getActiveSPS( sps->getSpsScalingListRefLayerId() ) ); 
+#else
   m_apcSlicePilot->setVPS( m_parameterSetManagerDecoder.getActiveVPS() );
+#endif
 #endif
   pps->setSPS(sps);
@@ -669,5 +695,9 @@
 
 #if H_MV
+#if H_MV5
+  m_apcSlicePilot->setRefPicSetInterLayer( & m_refPicSetInterLayer0, &m_refPicSetInterLayer1 ); 
+#else
   m_apcSlicePilot->setRefPicSetInterLayer( & m_refPicSetInterLayer ); 
+#endif
   m_apcSlicePilot->setLayerId( nalu.m_layerId );
 #endif
@@ -676,4 +706,13 @@
 #if H_MV  
   TComVPS* vps     = m_apcSlicePilot->getVPS();
+#if H_MV5
+  Int layerId  = nalu.m_layerId;   
+  setViewId   ( vps->getViewId   ( layerId )      );  
+#if H_3D
+  setViewIndex( vps->getViewIndex( layerId )      );  
+  setIsDepth  ( vps->getDepthId  ( layerId ) == 1 );  
+  m_ivPicLists->setVPS( vps ); 
+#endif
+#else
   Int layerIdInVps = vps->getLayerIdInVps( nalu.m_layerId );  
   setViewId   ( vps->getViewId   ( layerIdInVps )      );  
@@ -684,4 +723,5 @@
 #endif
 #endif
+#endif
     // Skip pictures due to random access
     if (isRandomAccessSkipPicture(iSkipFrame, iPOCLastDisplay))
@@ -723,4 +763,13 @@
 #endif
   // actual decoding starts here
+#if H_MV5
+#if H_MV
+   // This part needs further testing !
+   if ( m_apcSlicePilot->getPocResetFlag() )
+   {   
+     xResetPocInPicBuffer();
+   }
+#endif
+#endif
   xActivateParameterSets();
 
@@ -742,5 +791,9 @@
     m_apcSlicePilot->applyReferencePictureSet(m_cListPic, m_apcSlicePilot->getRPS());
 #if H_MV
+#if H_MV5
+    m_apcSlicePilot->createInterLayerReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer0, m_refPicSetInterLayer1 ); 
+#else
     m_apcSlicePilot->createAndApplyIvReferencePictureSet( m_ivPicLists, m_refPicSetInterLayer ); 
+#endif
 #endif
     //  Get a new picture buffer
@@ -888,9 +941,19 @@
     // Set reference list
 #if H_MV    
+#if H_MV5
+    std::vector< TComPic* > tempRefPicLists[2];
+    std::vector< Bool     > usedAsLongTerm [2];
+    Int       numPocTotalCurr;
+
+    pcSlice->getTempRefPicLists( m_cListPic, m_refPicSetInterLayer0, m_refPicSetInterLayer1, tempRefPicLists, usedAsLongTerm, numPocTotalCurr);
+    pcSlice->setRefPicList     ( tempRefPicLists, usedAsLongTerm, numPocTotalCurr, true ); 
+#else
     pcSlice->setRefPicList( m_cListPic, m_refPicSetInterLayer, true );    
+#endif
 #if H_3D_ARP
     pcSlice->setARPStepNum();
     if( pcSlice->getARPStepNum() > 1 )
     {
+      // GT: This seems to be broken, not all nuh_layer_ids are necessarily present
       for(Int iLayerId = 0; iLayerId < nalu.m_layerId; iLayerId ++ )
       {
@@ -1021,6 +1084,10 @@
   TComVPS* vps = m_parameterSetManagerDecoder.getPrefetchedVPS( 0 ); 
   assert( vps != 0 ); 
+#if H_MV5
+  m_cEntropyDecoder.decodeSPS( sps, vps->getViewIndex( m_layerId ), ( vps->getDepthId( m_layerId ) == 1 ) );
+#else
   Int layerIdInVPS = vps->getLayerIdInVps( m_layerId ); 
   m_cEntropyDecoder.decodeSPS( sps, vps->getViewIndex( layerIdInVPS ), ( vps->getDepthId( layerIdInVPS ) == 1 ) );
+#endif
 #else
   m_cEntropyDecoder.decodeSPS( sps );
@@ -1032,4 +1099,9 @@
 {
   TComPPS* pps = new TComPPS();
+#if H_MV5
+#if H_MV
+  pps->setLayerId( getLayerId() ); 
+#endif
+#endif
   m_cEntropyDecoder.decodePPS( pps );
   m_parameterSetManagerDecoder.storePrefetchedPPS( pps );
@@ -1040,9 +1112,25 @@
   if(nalUnitType == NAL_UNIT_SUFFIX_SEI)
   {
+#if H_MV5
+#if H_MV
+    m_seiReader.parseSEImessage( bs, m_pcPic->getSEIs(), nalUnitType, m_parameterSetManagerDecoder.getActiveSPS( m_layerId ) );
+#else
     m_seiReader.parseSEImessage( bs, m_pcPic->getSEIs(), nalUnitType, m_parameterSetManagerDecoder.getActiveSPS() );
+#endif
+#else
+    m_seiReader.parseSEImessage( bs, m_pcPic->getSEIs(), nalUnitType, m_parameterSetManagerDecoder.getActiveSPS() );  
+#endif
   }
   else
   {
+#if H_MV5
+#if H_MV
+    m_seiReader.parseSEImessage( bs, m_SEIs, nalUnitType, m_parameterSetManagerDecoder.getActiveSPS( m_layerId ) );
+#else
     m_seiReader.parseSEImessage( bs, m_SEIs, nalUnitType, m_parameterSetManagerDecoder.getActiveSPS() );
+#endif
+#else
+    m_seiReader.parseSEImessage( bs, m_SEIs, nalUnitType, m_parameterSetManagerDecoder.getActiveSPS() );
+#endif
     SEIMessages activeParamSets = getSeisByType(m_SEIs, SEI::ACTIVE_PARAMETER_SETS);
     if (activeParamSets.size()>0)
@@ -1051,5 +1139,13 @@
       m_parameterSetManagerDecoder.applyPrefetchedPS();
       assert(seiAps->activeSeqParamSetId.size()>0);
+#if H_MV5
+#if H_MV
+      if (! m_parameterSetManagerDecoder.activateSPSWithSEI(seiAps->activeSeqParamSetId[0], m_layerId ))
+#else
       if (! m_parameterSetManagerDecoder.activateSPSWithSEI(seiAps->activeSeqParamSetId[0] ))
+#endif
+#else
+      if (! m_parameterSetManagerDecoder.activateSPSWithSEI(seiAps->activeSeqParamSetId[0] ))
+#endif
       {
         printf ("Warning SPS activation with Active parameter set SEI failed");
@@ -1210,4 +1306,22 @@
 }
 
+#if H_MV5
+Void TDecTop::xResetPocInPicBuffer()
+{
+  TComList<TComPic*>::iterator  iterPic   = m_cListPic.begin();
+  while (iterPic != m_cListPic.end())
+  {
+    TComPic* pic = *(iterPic++);
+    if ( pic->getReconMark() )
+    {
+      for( Int i = 0; i < pic->getNumAllocatedSlice(); i++)
+      {
+        TComSlice* slice = pic->getSlice( i ); 
+        slice->setPOC ( slice->getPOC() - m_apcSlicePilot->getPocBeforeReset() );            
+      }         
+    }     
+  }
+}
+#endif
 #endif
 //! \}
Index: trunk/source/Lib/TLibDecoder/TDecTop.h
===================================================================
--- trunk/source/Lib/TLibDecoder/TDecTop.h	(revision 609)
+++ trunk/source/Lib/TLibDecoder/TDecTop.h	(revision 622)
@@ -216,5 +216,10 @@
   Int                     m_viewId;
   TComPicLists*           m_ivPicLists;
+#if H_MV5
+  std::vector<TComPic*>   m_refPicSetInterLayer0; 
+  std::vector<TComPic*>   m_refPicSetInterLayer1; 
+#else
   std::vector<TComPic*>   m_refPicSetInterLayer; 
+#endif
 #if H_3D
   Int                     m_viewIndex; 
@@ -274,4 +279,7 @@
   TComPic*  xGetPic( Int layerId, Int poc ); 
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay, Bool newLayerFlag );  
+#if H_MV5
+  Void      xResetPocInPicBuffer();
+#endif
 #else
   Bool      xDecodeSlice(InputNALUnit &nalu, Int &iSkipFrame, Int iPOCLastDisplay);
